// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js

var REMOTEAPI_HOME = "https://kts.korloy.com"; // 운영 DB
//버전
var androidVer = "1.0.4";
var IOSVer = "1.0.4";
var currentVer = "0.0.0";
var app = angular.module('starter', ['ionic',
                           			'starter.controllers', 
                           			'starter.services',
                           			'update.services',
                           			'comm.controllers',
                           			'home.controllers',
                           			'calculator.controllers',
                           			'converter.controllers',
                           			'more.controllers',
                           			'comm.services',
                           			'calculator.services',
                           			'pascalprecht.translate',
                           			'toaster', 
                           			'ngAnimate',
                           			'LocalStorageModule'
                           			])

app.run(function($ionicPlatform,$rootScope,$translate,$ionicSideMenuDelegate, $location, toaster,$state,$ionicHistory,httpService,$filter, $http, $cacheFactory, localStorageService,$ionicPopup) {
	/**************************
	 *  global value;
	 **************************/
	$rootScope.logFlag = true;
	$rootScope.manifestRoot = Manifest.root;

	// cache update기본 설정을 한다.
    window.BOOTSTRAP_OK = true;
    //기계효율 상수 설정
    $rootScope.Pcst = 0.8;
    // conv search view 설정
    $rootScope.searchFlag = false;

	/************************** 
	 * functions 
	 **************************/
	$rootScope.verChk = function(){
		switch(ionic.Platform.platform()){
			case 'android':
				if(!angular.equals(currentVer, androidVer)){

					alert($rootScope.transConv('alert08'));
					window.open('https://play.google.com/store/apps/details?id=com.korloy.mobile.kts', '_system');
					UpdateService.cacheDelete();
					navigator.app.exitApp();
					return;
				}
				break;
			case 'ios' :
				if(!angular.equals(currentVer, IOSVer)){
					alert($rootScope.transConv('alert08'));
					window.open('https://itunes.apple.com/kr/app/kts/id1066158688?mt=8', '_system');
					UpdateService.cacheDelete();
					navigator.app.exitApp();
					return;
				}
				break;
			default : 
				break;
		};
	};
	$rootScope.logService =function(app, flag, code,cptCode , appCode){
		if(typeof cptCode == 'undefined') cptCode = null;
		if(typeof appCode == 'undefined') appCode = null;
			if($rootScope.logFlag){
			var data =new FormData();      
				data.append('app', app);
				data.append('flag', flag);
				data.append('code', code);
				data.append('os', $rootScope.logPlatform());
				data.append('cptCode' ,  cptCode);
				data.append('appCode' ,  appCode);

				  httpService.InsertInfo(data, '/admin/log.do').error(function(response){
				  	$rootScope.logFlag = false;
				  });
			}else {
				return;
			}
	};

	$rootScope.logPlatform = function(){
		console.log(ionic.Platform.platform());
		switch(ionic.Platform.platform()){
			case 'android':
				return '01';
				break;
			case 'ios' :
				return '02';
				break;
			default : 
				return '03';
				break;
		};
	};
	
	$rootScope.manifestRootImage = function(imgPath) {
		return Manifest.root + imgPath;
	};

	  $rootScope.ChangeLanguage = function(lang){

		  $rootScope.lang = lang;
		  $translate.use(lang);
		  localStorageService.set('lang',lang);
		  // converter Init 실행. 
		  $rootScope.$broadcast("CONVERTER_CHANGE_LANGUAGE");
		
	  };
	  
	  $rootScope.ChangeUnitName = function(unit , itm){
	  	switch(itm) {
	  		case 'vc' :
	  			return unit == 'mm'?'m/min':'ft/min';
	  			break;
	  		case 'n' :
	  			return unit == 'mm'?'rpm':'rpm';
	  			break;
	  		case 'vf' :
	  			return unit == 'mm'?'mm/min':'inch/min';
	  			break;

	  		case 'fn' :
	  			return unit == 'mm'?'mm/rev':'inch/rev';
	  			break;

	  		case 'fz' :
	  			return unit == 'mm'?'mm/t':'inch/t';
	  			break;

	  		case 'Q' :
	  			return unit == 'mm'?'cm³/min':'inch³/min';
	  			break;
	  		case 'Pc' :
	  			return unit == 'mm'?'kw':'kw';
	  			break;

	  		case 'Mc' :
	  			return unit == 'mm'?'kgf cm':'lbf. ft';
	  			break;

	  		case 'T' :
	  			return unit == 'mm'?'kgf':'kgf';
	  			break;
	  		case 'Kc' :
	  			return unit == 'mm'?'Mpa':'lbs/inch²';
	  			break;

	  		case 'Dm' :
	  			return unit == 'mm'?'mm':'inch';
	  			break;

	  		case 'ap' :
	  			return unit == 'mm'?'mm':'inch';
	  			break;

	  		case 'ae' :
	  			return unit == 'mm'?'mm':'inch';
	  			break;

	  		case 'Zc' :
	  			return unit == 'mm'?'pcs':'pcs';
	  			break;
	  		case 'K' :
	  			return unit == 'mm'?'':'';
	  			break;
	  	}

	  };
	  $rootScope.ChangeUnit = function(unit){
	  	$rootScope.unit = unit;
	  	localStorageService.set('unit',unit);
		switch(unit) {
			case 'mm':
				$rootScope.inchUnit = {
					vc : 1,
					n: 1,
					vf : 1,
					fn:1,
					fz:1,
					Q:1,
					Pc:1,
					Mc: 1,
					Kc:1,
					Dm: 1,
					ap: 1,
					ae: 1,
					Zc: 1
				};

				$rootScope.decimalNum = 2;
				break;
			case 'inch' :
				$rootScope.inchUnit = {
					vc : 3.28084,
					n: 1,
					vf : 1/25.4,
					fn:1/25.4,
					fz:1/25.4,
					Q:1/(2.54^3),
					Pc:1,
					Mc: 0.07233,
					Kc:25.4^2,
					Dm: 1/25.4,
					ap: 1/25.4,
					ae: 1/25.4,
					Zc: 1
				};
				$rootScope.decimalNum = 3;
				break;
		};
	  };

	$rootScope.kts_underLine = function(val, nm , cv){
		switch(val) {
			case 'T':
				var arr = [4,5];
				if(arr.indexOf(cv) > -1){
					return 'kts-under';
				}else{
					return '';
				}
				break;
			case 'M':
				var arr = [4,5];
				if(arr.indexOf(cv) > -1){
					if(nm == 'fz'){
						if(angular.equals(cv,5)){
							return 'kts-under';		
						}else{
							return '';
						}
					}else{
						return 'kts-under';
					}
				}else{
					return '';
				}
				break;
			case 'G':
				var arr = [4,5];
				if(arr.indexOf(cv) > -1){
					return 'kts-under';
				}else{
					return '';
				}
				break;
			case 'D':
				var arr =[4,5];
				var arr1 = [4,5,6,7];
				//k 67 vc 45 fn 4567
				if(arr1.indexOf(cv) > -1){
					if(nm == 'vc'){
						if(arr.indexOf(cv) > -1){
							return 'kts-under';
						}else{
							return '';
						}
					}else if(nm =='K'){
						if(arr.indexOf(cv) > -1){
							return '';
						}else{
							return 'kts-under';
						}
					}
					return 'kts-under';
				}else{
					return '';
				}
				break;

		}
	};

	$rootScope.ChangeView = function(str){
        if(angular.equals(str,"/kts/conv/grade")){
            console.log("/kts/conv/grade");
            $rootScope.logService('01' ,'01' ,'MT00001' );
            //$rootScope.$broadcast("CONVERTER_CHANGE_LANGUAGE");
        }
		$location.path(str);
		//$state.go("kts.conv.grade");
	};

	$rootScope.goHome = function(){
		if($rootScope.logPlatform() == '03') return;
		//$ionicHistory.clearHistory();
		$location.path("home");
	};

	$rootScope.goBack = function(){
		$ionicHistory.goBack();
	};

	
	$rootScope.getText = function(text){
		if (typeof text.en == 'undefined') {
			text.en = text.ko;
		};
		
		if (typeof text.ko == 'undefined') {
			text.ko = text.en;
		};
		
		if($rootScope.lang == 'en') {
			return text.en;
		} else {
			return text.ko;
		}
	};
	
	$rootScope.pop = function(opt,title,text){
        		toaster.pop(opt, title , text);
	};
        	$rootScope.onTextClick = function($event){
    		$event.target.select();
    		$event.target.select();
	};
        	$rootScope.miniCalcResult = function(event){
        		event.preventDefault();
        		$rootScope.pop('info','',$rootScope.transConv('canNotWrite')); 
	};
	
	// android 여부
	$rootScope.isAndroid = function() {
		var userAgent = navigator.userAgent.toLowerCase();
		if( userAgent.search("android")>-1){
			return true;
		}
		return false;
	};
	// ios 여부
	$rootScope.isIOS = function() {
		var userAgent = navigator.userAgent.toLowerCase();
		if( userAgent.search("ios")>-1){
			return true;
		}
		return false;
	};
	// browser open
	$rootScope.OpenWindow =function(addr){
		var openUrl =  addr ;
		if($rootScope.isAndroid()){
		  //navigator.app.loadUrl(openUrl, {openExternal : true});
			cordova.InAppBrowser.open(openUrl,'_blank','location=yes');
		} else {
			window.open(openUrl, '_system');
		}
		
	};
		  
	$rootScope.getTel = function(tel){
		if($rootScope.isAndroid()){
			window.open('tel:' + tel, '_system');
		} else{
			window.location.href = "tel:" + tel;
		}
	};

	$rootScope.getMail = function(mail){
		if($rootScope.isAndroid()){
			window.open('mailto:' + mail, '_system');
		} else{
			window.location.href = "mailto:" + mail;
		}
	};
			
	$rootScope.fnInsertLog = function (flag ,code ,cptCode ,appCode){
			  
		var logData = {
			  app:'APP', // {01:재종변환기, 02:절삭계산기}
			  flag:'FLAG', // {01:메뉴, 02:재종코드}
			  code:'CODE', // {"메뉴코드", "재종코드"}
			  os:'ANDROID', // {01:Android, 02:IOS, 03:WEB}
			  cptCode: cptCode || '', // 경쟁사 코드
			  appCode: appCode || ''  // 어플리케이션 코드
		}
		
		$http.get(REMOTEAPI_HOME+"/admin/log.do?" +
			"app="+logData.app+"&" +
			"flag="+logData.flag+"&" +
			"code="+logData.code+"&" +
			"os="+logData.os+"&" +
			"cptCode="+logData.cptCode+"&" +
			"appCode="+logData.appCode
		)
		.success(function(data, status, headers, config){
			  console.log('success!!');
		})
		.error(function(data,status,headers, config){
			  console.log('error!!');
		});
	};
		  
	$rootScope.selectJSON = function(){
		var dataUrl = Manifest.root+"kts-comm/ktsConvData.json";
		console.log("json start..");
		httpService.getConvData(dataUrl).then(function(result){
			  $rootScope.ktsConvData = result.data;
			  $rootScope.ktsConvGD = result.data.data[0].brand;
			  $rootScope.ktsConvCB = result.data.data[1].brand;
			  $rootScope.changeData('GD');
		});
	};
		  
	$rootScope.changeData = function(ftype){
		$rootScope.ftype = ftype || 'GD';
		$rootScope.lmf = [];
		$rootScope.app = [];
		$rootScope.item= [];
	  
		if(angular.equals(ftype,"GD")){
			  $rootScope.lmf = $rootScope.ktsConvGD;
		} else {
			  $rootScope.lmf = $rootScope.ktsConvCB;
		};
	};
		  
	$rootScope.filterComp = function(code){
		  for ( var i in $rootScope.ktsConvData.brand) {
			  if(angular.equals(code , $rootScope.ktsConvData.brand[i].code)){
				  return $rootScope.name2lang($rootScope.ktsConvData.brand[i].name);
			  }
		}
	};
		  
		  
	$rootScope.filterApplication= function(mcode, code , dataSet, flag){
		for ( var i in dataSet) {
			  if(angular.equals(mcode , dataSet[i].code)){
				  for ( var j in dataSet[i].brand) {
					  if(angular.equals(code, dataSet[i].brand[j].code)){
						  return $rootScope.app2code(dataSet[i].brand[j].code,dataSet[i].brand[j].app , flag);
					  }
				  }
			  }
		}
	};
		  

	$rootScope.filterItem = function(comp, app, dataSet){
		  var itemName = [];
		  for ( var i in dataSet) {
	//				  for ( var j in app) {
		  if(angular.equals(comp , dataSet[i].brand) && angular.equals(app , dataSet[i].app)){
	//						  return dataSet[i].item;
			  itemName.push({name: dataSet[i].item, convert: dataSet[i].convert});
		  }
	//				  }
		  }
		 
		  return itemName;
	};
		  
		  

	$rootScope.app2code = function(comp, app, flag) {
		var appName = [];
		for ( var i in app) {
			for ( var j in $rootScope.ktsConvData.app) {
				if (angular.equals(app[i], $rootScope.ktsConvData.app[j].code)) {
					appName.push({
						name : $rootScope.name2lang($rootScope.ktsConvData.app[j].name),
						item : $rootScope.filterItem(comp, $rootScope.ktsConvData.app[j].code, $rootScope.ktsConvData.search)
					});
				}
			}
		}

		return appName;
	};
		  
	$rootScope.name2lang = function(name, langCode) {
		var lang = langCode || '';
	
		if (angular.equals(lang, '')) {
			lang = $rootScope.lang;
		}
	
		if (lang == 'ko') {
			return name.ko;
		} else if (lang == 'en') {
			return name.en;
		} else {
			return name.en;
		}
	};


	// 코드 언어번환
	$rootScope.fnConvLanguage = function(key,code,mcode,lang){
		if (!$rootScope.ktsConvData) return;
		
		var data = [];
		var resultName = "";
		
		switch (key) {
			
			case "FTYPE":
				data = $rootScope.ktsConvData.ftype;
				for (var i = 0; i < data.length; i++) {
					if(angular.equals(data[i].code,code)){
						resultName = $rootScope.name2lang(data[i].name,lang);
						break;
					}
				}
				break;
				
			case "COMP":
				data = $rootScope.ktsConvData.competitors;
				for (var i = 0; i < data.length; i++) {
					if(angular.equals(data[i].code,code)){
						resultName = $rootScope.name2lang(data[i].name);
						break;
					}
				}
				break;
	
			case "APP":
				data = $rootScope.ktsConvData.applications;
				for (var i = 0; i < data.length; i++) {
					if(angular.equals(data[i].code,code)&&angular.equals(data[i].mcode,mcode)){
						resultName = $rootScope.name2lang(data[i].name);
						break;
					}
				}
				break;
	
			default:
				console.log("코드종류가 없습니다.");
				break;
		}
		return resultName;
	};
	
	
    // 다국어 text 가져오기
	$rootScope.transConv = function(key){
		  return $filter('translate')(key);
	};
	  
	$rootScope.typeOf = function(value) {
	    return typeof value;
	};
	  
	$rootScope.getLanguageCode = function (){
		var resultLang = localStorageService.get('lang') == null ? undefined : localStorageService.get('lang');
		var resultUnit = localStorageService.get('unit') == null ? undefined : localStorageService.get('unit');
		if(!resultLang){
			if (navigator.userLanguage) {
			  	resultLang = navigator.userLanguage.substring(0,2).toLowerCase();
			} else {
				resultLang = navigator.language.substring(0,2).toLowerCase();
			}
		} 
		
		switch(resultLang)
		{
			case "ko":
				resultUnit = resultUnit || 'mm';
				break;
			case "en":
				resultUnit = resultUnit || 'inch';
				/* english */
				break;
			default:
				resultLang = "en";
				resultUnit = resultUnit || 'mm';
		}
		$rootScope.ChangeLanguage(resultLang);
		$rootScope.ChangeUnit(resultUnit);
	};
	
		   
	//백버튼 인터셉터
	$ionicPlatform.registerBackButtonAction(function() {
		try{
			if ($state.current.name == 'kts.conv.grade' || $state.current.name == 'kts.calc' || $state.current.name == 'kts.cont' ){
					$state.go('home');
			}else if ($state.current.name == "home") {
		
				//$ionicHistory.clearHistory();
			
				$ionicPopup.confirm({
						     title: $rootScope.transConv('closeAppTitle'),
						     template:$rootScope.transConv('closeApp')
				}).then(function(result){
					if(result){
						navigator.app.exitApp();
					}
				});
			}else{
		    	$ionicHistory.goBack(-1);
		    }
		}catch(ex){
			alert(ex);
			console.log(ex);
		
		}
	
	}, 100);	
	
	/*******************************
	 * SETTING
	 *******************************/
	$ionicPlatform.ready(function() {

	    // 언어 설정.  
	    $rootScope.getLanguageCode(); 
		//로그 저장
		$rootScope.logService('03', '01' , 'MK00001');

		if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
			cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
			cordova.plugins.Keyboard.disableScroll(true);
		}

		if (window.StatusBar) {
		  StatusBar.styleLightContent();
		}
		if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
			cordova.getAppVersion(function(version) {
				currentVer = version;
				$rootScope.verChk();
			});
		}
		//  json read
		$rootScope.selectJSON();  
	});
});