// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js


app.config(['$stateProvider', '$urlRouterProvider', '$httpProvider', function ($stateProvider, $urlRouterProvider, $httpProvider, $rootScope) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider
  .state('home-update', {
	  url: "/update",
	  views: {
	    'menuContent' :{
	    	templateUrl: 'home/view/intro.html',
	    	controller: 'IntroCtrl'
	    }
	  }
  })
.state('tab.calc', {
	  url: "/calc",
	  views: {
	    'tab-calc' :{
	    	templateUrl: 'kts-cal/view/selectCal.html',
	    	controller: 'selectCalCtrl'
	    }
	  }
  })

.state('tab.turning', {
	    url: '/turning',
	    views: {
	    	'tab-calc' :{
	    		templateUrl: 'kts-cal/view/turning.html',
	    	    controller: 'TurningCtrl'
	    	}
	    }
	    
  }) 
    
    
  .state('tab.milling', {
	    url: '/milling',
	    views: {
	    	'tab-calc' :{
		    templateUrl: 'kts-cal/view/milling.html',
		    controller: 'MillingCtrl'
	    	}
	    }
  })
  
    .state('tab.grooving', {
	    url: '/grooving',
	    views: {
	    	'tab-calc' :{
		    templateUrl: 'kts-cal/view/grooving.html',
		    controller: 'GroovingCtrl'
	    	}
	    }
  })
  .state('tab.drilling', {
	    url: '/drilling',
	    views: {
	    	'tab-calc' :{
		    templateUrl: 'kts-cal/view/drilling.html',
		    controller: 'DrillingCtrl'
	    	}
	    }
  })


  //converter.home
  .state('tab.conv', {
	  	url: '/conv',
	  	views : {
	  		'tab-conv':{
	  			templateUrl: 'kts-conv/view/converter.html',
	  			controller: 'ConverterCtrl'
	  		}
	  	}
  })
    
    
  .state('tab.resultView', {
	    url: '/resultView',
	  	views : {
	  		'tab-conv':{
	  			templateUrl: 'kts-conv/view/resultView.html',
	  			controller: 'ResultCtrl'
	  		}
	  	}
  })

  .state('tab.more', {
	  	url: '/more',
	  	views:{
	  		'tab-more' : {
	  			templateUrl: 'kts-more/view/more.html',
	  			controller: 'moreCtrl'
	  		}
	  	}
		
  })

  //converter.home
  .state('tab', {
	  	url: '/tab',
	  	abstract:true,
	  	views:{
	  		'menuContent' : {
	  			templateUrl: 'kts-comm/view/tabs.html'	
	  		}
	  	}
		
  })

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/tab/conv');
}]);
