// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js


app.config(['$stateProvider', '$urlRouterProvider', '$httpProvider', function ($stateProvider, $urlRouterProvider, $httpProvider, $rootScope) {
	
	/**
	 * URL를 정의.
	 */
	$stateProvider
	.state('home', {
		url: "/home",
		templateUrl: 'home/view/root.html',
		controller: 'HomeCtrl'
	})

	.state('update', {
		url: "/update",
				templateUrl: 'home/view/intro.html',
				controller: 'IntroCtrl'
	})
	
    .state('kts', {
        url : '/kts',
        templateUrl : 'kts-comm/view/slideMenu.html',
        controller: 'SideMenuCtrl',
        abstract : true,
        cache:false
    })
            
	.state('kts.calc', {
		url: "/calc",
		views: {
			'menuContent' :{
				templateUrl: 'kts-cal/view/selectCal.html',
				controller: 'selectCalCtrl'
			}
		}
	})
	
	.state('kts.cont', {
		url: "/cont",
		views: {
			'menuContent' :{
				templateUrl: 'home/view/contact-us.html'
			}
		}
	})
	
	.state('kts.turning', {
	    url: '/turning',
	    views: {
	    	'menuContent' :{
	    		templateUrl: 'kts-cal/view/turning.html',
	    	    controller: 'TurningCtrl'
	    	}
	  		,'fabContent': {
				template: '<button id="fab-activity" class="button button-fab button-fab-top-right expanded button-energized-900 flap"><i class="icon ion-paper-airplane"></i></button>',
				controller: function ($timeout) {
					$timeout(function () {
						alert("이리콤");
						document.getElementById('fab-activity').classList.toggle('on');
					}, 1000);
				}
			}

	    }
	    
	}) 
    
	.state('kts.milling', {
	    url: '/milling',
	    views: {
	    	'menuContent' :{
		    templateUrl: 'kts-cal/view/milling.html',
		    controller: 'MillingCtrl'
	    	}
	    }
	})
  
    .state('kts.grooving', {
	    url: '/grooving',
	    views: {
	    	'menuContent' :{
		    templateUrl: 'kts-cal/view/grooving.html',
		    controller: 'GroovingCtrl'
	    	}
	    }
    })
    .state('kts.drilling', {
	    url: '/drilling',
	    views: {
	    	'menuContent' :{
		    templateUrl: 'kts-cal/view/drilling.html',
		    controller: 'DrillingCtrl'
	    	}
	    }
    })


    //converter.home
    .state('kts.conv', {
	  	url: '/conv',
	  	abstract : true,
	  	cache:false,
	  	views : {
	  		'menuContent':{
	  			templateUrl: 'kts-conv/view/tabs.html',
	  			controller: 'ConverterCtrl'
	  		}
	  	}
    })
    
    
    //converter.home
    .state('kts.conv.grade', {
	  	url: '/grade',
	  	views : {
	  		'convContent':{
	  			templateUrl: 'kts-conv/view/converter.html',
	  			controller: 'ConverterCtrl1'
	  		}
	  	}
    })
    
    //converter.home
    .state('kts.conv.cb', {
	  	url: '/cb',
	  	views : {
	  		'convContent':{
	  			templateUrl: 'kts-conv/view/converter.html',
	  			controller: 'ConverterCtrl1'
	  		}
	  	}
    })
    
    
    .state('kts.resultView', {
	    url: '/resultView',
	  	views : {
	  		'menuContent':{
	  			templateUrl: 'kts-conv/view/resultView.html',
	  			controller: 'ResultCtrl'
	  		}
	  	}
    })
    
    .state('kts.more', {
		url: "/more",
		views: {
			'menuContent' :{
				templateUrl: 'kts-more/view/more.html',
				controller: 'moreCtrl'
			}
		}
	});
	
	if(angular.equals(ionic.Platform.platform(),"android")||angular.equals(ionic.Platform.platform(),"ios")){
		$urlRouterProvider.otherwise('/home');
	} else {
		$urlRouterProvider.otherwise('/kts/conv/grade');
	}
	//console.log($rootScope.logPlatform());
    // if none of the above states are matched, use this as the fallback
    
}])


.config( [ '$compileProvider','$ionicConfigProvider', function( $compileProvider, $ionicConfigProvider) {
	$ionicConfigProvider.tabs.position('bottom');
	$ionicConfigProvider.views.swipeBackEnabled(false);
	$compileProvider.imgSrcSanitizationWhitelist(/^\s*((https?|ftp|file|blob|chrome-extension|cdvfile):|data:image\/)/);
 
	// Angular before v1.2 uses $compileProvider.urlSanitizationWhitelist(...) 
}]);
