angular.module('starter.services', [])

/**
 * selectable search
 */
.filter('setDecimal', function($filter) {
	return function(input, places) {
		if (isNaN(input))
			return input;
		// If we want 1 decimal place, we want to mult/div by 10
		// If we want 2 decimal places, we want to mult/div by
		// 100, etc
		// So use the following to create that factor
		var factor = "1"
				+ Array(+(places > 0 && places + 1)).join("0");
				return Math.round(input * factor) / factor;
			};
	}
)

/**
 * Might use a resource here that returns a JSON array
 * Some fake testing data
 */		
.factory('Chats', function() {
	var chats = [
			{
				id : 0,
				name : 'Ben Sparrow',
				lastText : 'You on your way?',
				face : 'https://pbs.twimg.com/profile_images/514549811765211136/9SgAuHeY.png'
			},
			{
				id : 1,
				name : 'Max Lynx',
				lastText : 'Hey, it\'s me',
				face : 'https://avatars3.githubusercontent.com/u/11214?v=3&s=460'
			},
			{
				id : 2,
				name : 'Adam Bradleyson',
				lastText : 'I should buy a boat',
				face : 'https://pbs.twimg.com/profile_images/479090794058379264/84TKj_qa.jpeg'
			},
			{
				id : 3,
				name : 'Perry Governor',
				lastText : 'Look at my mukluks!',
				face : 'https://pbs.twimg.com/profile_images/598205061232103424/3j5HUXMY.png'
			},
			{
				id : 4,
				name : 'Mike Harrington',
				lastText : 'This is wicked good ice cream.',
				face : 'https://pbs.twimg.com/profile_images/578237281384841216/R3ae1n61.png'
			} ];

	return {
		all : function() {
			return chats;
		},
		remove : function(chat) {
			chats.splice(chats.indexOf(chat), 1);
		},
		get : function(chatId) {
			for (var i = 0; i < chats.length; i++) {
				if (chats[i].id === parseInt(chatId)) {
					return chats[i];
				}
			}
			return null;
		}
	};
});

