angular.module('comm.services', [])

.directive('focusMe', function($timeout) {
	  return {
	    scope: { trigger: '=focusMe' },
	    link: function(scope, element) {
	      scope.$watch('trigger', function(value) {
	        if(value === true) { 
	          //console.log('trigger',value);
	          //$timeout(function() {
	            element[0].focus();
	            scope.trigger = false;
	          //});
	        }
	      });
	    }
	  };
	})
//Fancy select directive
.directive('fancySelect', function($ionicModal, $timeout) {
    return {
        /* Only use as <fancy-select> tag */
        restrict : 'E',

        /* Our template */
        templateUrl: 'kts-comm/view/fancy-select.html',
       //  replace:true,
       //  replace:true,
        /* Attributes to set */
        scope: {
        	'callback'	:'=',
            'items'        : '=', /* Items list is mandatory */
            'value'        : '=', /* Selected value binding is mandatory */
            'lang'			 : '=lang'
            
        },

        link: function (scope, element, attrs, $filter, $timeout) {

            /* Default values */
            scope.multiSelect   = attrs.multiSelect === 'true' ? true : false;
            scope.allowEmpty    = attrs.allowEmpty === 'false' ? false : true;
            /* Header used in ion-header-bar */
            scope.headerText    = attrs.headerText || '';
//            scope.lang = attrs.lang || '';

            /* Text displayed on label */
            scope.text          = attrs.text || '';
            scope.defaultText   = attrs.text || '';
            scope.labelText = attrs.labelText || '';
            
            /* Notes in the right side of the label */
            scope.noteText      = attrs.noteText || '';
            scope.noteImg       = attrs.noteImg || '';
            scope.noteImgClass  = attrs.noteImgClass || '';
            /* Instanciate ionic modal view and set params */

            /* Some additionnal notes here : 
             * 
             * In previous version of the directive,
             * we were using attrs.parentSelector
             * to open the modal box within a selector. 
             * 
             * This is handy in particular when opening
             * the "fancy select" from the right pane of
             * a side view. 
             * 
             * But the problem is that I had to edit ionic.bundle.js
             * and the modal component each time ionic team
             * make an update of the FW.
             * 
             * Also, seems that animations do not work 
             * anymore.
             * 
             */
            $ionicModal.fromTemplateUrl(
                'kts-comm/view/fancy-select-items.html',
                  { 'scope': scope,
                    'animation': 'slide-in-up' }
            ).then(function(modal) {
                scope.modal = modal;
                //scope.modal.show();
            });

            /* Validate selection from header bar */
            scope.validate = function (event) {
                // Construct selected values and selected text
                if (scope.multiSelect == true) {

                    // Clear values
                    scope.value = '';
                    scope.text = '';

                    // Loop on items
                    jQuery.each(scope.items, function (index, item) {
                        if (item.checked) {
                            scope.value = scope.value + item.id+';';
                            scope.text = scope.text + item.text+', ';
                        }
                    });

                    // Remove trailing comma
                    scope.value = scope.value.substr(0,scope.value.length - 1);
                    scope.text = scope.text.substr(0,scope.text.length - 2);
                }

                // Select first value if not nullable
                if (typeof scope.value == 'undefined' || scope.value == '' || scope.value == null ) {
                    if (scope.allowEmpty == false) {
                        scope.value = scope.items[0].id;
                        scope.text = scope.items[0].text;

                        // Check for multi select
                        scope.items[0].checked = true;
                    } else {
                        scope.text = scope.defaultText;
                    }
                }

                // Hide modal
                scope.hideItems();
            };

            /* Show list */
            scope.showItems = function (event) {
                event.preventDefault();
                console.log(scope.modal);
                /*if(typeof scope.modal  == 'undefined'){
                  return false;
                }*/
                  scope.modal.show() ;
                  /*return true;*/
              
            };

            /* Hide list */
            scope.hideItems = function () {
                scope.modal.hide();
            };

            /* Destroy modal */
            scope.$on('$destroy', function() {
              scope.modal.remove();
            });

           /* scope.item2logInfo = function(item){
              console.log(item);
            };*/



            /* Validate single with data */
            scope.validateSingle = function (item,idx) {
              //scope.item2logInfo(item);
              scope.$root.logService('02', '01' , item.code);
                // Set selected text
                scope.text = item.name;

                // Set selected value
                scope.value = idx;
                // Hide items
                scope.hideItems();
            };
        }
    };
})


.directive('focusOn', function() {
   return function(scope, elem, attr) {
      scope.$on('focusOn', function(e, name) {
        if(name === attr.focusOn) {
          elem[0].focus();
        }
      });
   };
})

.factory('focus', function ($rootScope, $timeout) {
  return function(name) {
    $timeout(function (){
      $rootScope.$broadcast('focusOn', name);
    });
  }
})

//http통신 서비스 선언.
.factory("httpService",["$http" , function($http){
	return {
		//조회 -- create : dk
		SelectInfo: function(formInfo, urlInfo){
			return  $http({url: REMOTEAPI_HOME + urlInfo, 
		        method:"POST", 
		        data: formInfo}).
		      success(function(data, status, headers, config) {
		    	  return data;
		      }).
		      error(function(data, status, headers, config) {
		    	  return data;
		      });
		}
	, SelectGet: function(formInfo, urlInfo){
		return  $http({url: REMOTEAPI_HOME + urlInfo, 
	        method:"GET", 
	        data: formInfo}).
	      success(function(data, status, headers, config) {
	    	  return data;
	      }).
	      error(function(data, status, headers, config) {
	    	  return data;
	      });
	}
	, getConvData: function(dataUrl){
		//cdvfile://localhost/persistent/app/lib/kts-comm/ktsConvData.js
		return  $http({url: dataUrl, 
	        method:"GET"}).
	      success(function(data, status, headers, config) {
	    	  return data;
	      }).
	      error(function(data, status, headers, config) {
	    	  return data;
	      });
	}
		,
		//저장 -- create : dk
		InsertInfo: function(formInfo, urlInfo){
			console.log(formInfo);
			console.log(urlInfo);
                return  $http.post(
                  REMOTEAPI_HOME + urlInfo, formInfo,
                      {transformRequest: angular.identity,
                      headers:{'Content-Type':undefined}}
                  ).
		        success(function(data, status, headers, config) {
              console.log('success');
		        }).
		        error(function(data, status, headers, config) {
              console.log('fail');
		        });
		}

    /*  
		,
		//파일저장 -- create : dk
		InsertFileInfo: function(formInfo, urlInfo){
			console.log(formInfo);
			console.log(urlInfo);
			return  $http.post(
				REMOTEAPI_HOME + urlInfo, formInfo,
		      	{transformRequest: angular.identity,
		      	headers:{'Content-Type':undefined}}
				).
		        success(function(data, status, headers, config) {
		        }).
		        error(function(data, status, headers, config) {
		        });
		}
		,
		//업데이트 -- create : dk
		UpdateInfo: function(formInfo, urlInfo){
			console.log(formInfo);
			console.log(urlInfo);
			return  $http({url: REMOTEAPI_HOME + urlInfo, 
		        method:"POST", 
		        ignoreLoadingBar: true,
		        data: formInfo}).
		        success(function(data, status, headers, config) {
		        }).
		        error(function(data, status, headers, config) {
		        });
		}
		,
		//삭제 --create : dk
		DeleteInfo: function(formInfo, urlInfo){
			console.log(formInfo);
			console.log(urlInfo);
			return  $http({url: REMOTEAPI_HOME + urlInfo, 
		        method:"POST", 
		        ignoreLoadingBar: true,
		        data: formInfo}).
		        success(function(data, status, headers, config) {
		        }).
		        error(function(data, status, headers, config) {
		        });
		}*/
	};
}]);