angular.module('converter.controllers', [])

.controller('sqTestCtrl', function($scope) {

})

.filter('searchfilter',function(){
	
	return function(items, field, reverse) {
	    var filtered = [];
	    
	    angular.forEach(items, function(item) {
	    	filtered.push(item.item);
	    });
	    
	    filtered.sort(function (a, b) {
	    	return (a[field] > b[field] ? 1 : -1);
	    });
	    
	    if(reverse) filtered.reverse();
	    
	    return filtered;
	};

})

.controller('ConverterCtrl', function($scope,$rootScope,$location,$ionicScrollDelegate,$filter,$ionicModal,$translate,$timeout,$ionicPlatform,$ionicTabsDelegate) {
	
	$scope.modal;
	$scope.codeModal;
	$scope.popupType;
	
	$scope.lmfName = "";
	$scope.appName = "";
	$scope.itemName = "";
	$scope.items = [];
	$rootScope.convData = [];
	$scope.isFtypeBtnCheck = true;
	
	// tab select
	$scope.selectTabWithIndex = function(index) {
		$ionicTabsDelegate.select(index);
		$scope.tabSelected(index == 0? "GD" : "CB");
	};
	// 화면세팅 초기화 호출
	$rootScope.$on('CONVERTER_CHANGE_LANGUAGE', function(event, pageNo) {
		$scope.converterInit($rootScope.ftype);
	});
	
	// 화면세팅 초기화
	$scope.converterInit = function(ftype){
		console.log("converter init...!");
		$rootScope.changeData(ftype);
		// input 초기화
		$scope.code = {};
		$scope.lmfName = $rootScope.transConv('conv01');
		$scope.appName = $rootScope.transConv('conv01');
		$scope.itemName = $rootScope.transConv('conv01');
		$scope.search.item = ""; // search 초기화
		$scope.search.string = "";
	    $scope.code.lmf = undefined;
	    $scope.code.app = undefined;
	    $scope.code.item = undefined;
		$scope.lmfItems = undefined;
		$scope.appItems = undefined;
	};
	
	// modal
	$scope.showItems = function (type, event) {
		event.preventDefault();
		var checkValue = [];
		var popupTitle = "";
    	switch(type){
			case 'lmf':
				$scope.items =$rootScope.lmf;
				$scope.currentCode=$scope.code.lmf;
				popupTitle = $rootScope.transConv('conv06');
				break;
				
			case 'app':
				if($scope.chkUndefined($scope.code.lmf)) {
					$rootScope.pop('info','',$rootScope.transConv('alert01')) ;
					return;
				}
				$scope.items =$rootScope.lmf[$scope.getListIndex($rootScope.lmf,$scope.code.lmf)].app;
				$scope.lmfItems = $scope.items;
				$scope.currentCode=$scope.code.app;
				if($scope.chkUndefined($scope.items[0])){
		    		
		    		$scope.items = [];
		    		$rootScope.pop('info','',$rootScope.transConv('alert03'));
		    		return false; 
		    	}
				popupTitle = $rootScope.transConv('conv07');
				break;
				
			case 'item':
				if($scope.chkUndefined($scope.code.lmf)){
					$rootScope.pop('info','',$rootScope.transConv('alert01')); 
					return;
				}else if($scope.chkUndefined($scope.code.app)){
					$rootScope.pop('info','',$rootScope.transConv('alert02'));
					return;
				}
				$scope.items =$scope.lmfItems[$scope.getListIndex($scope.lmfItems,$scope.code.app)].items;
				$scope.appItems = $scope.items;
				$scope.currentCode=$scope.code.item;
				if($scope.chkUndefined($scope.items[0])){
		    		
		    		$scope.items = [];
		    		$rootScope.pop('info','',$rootScope.transConv('alert04'));
		    		return false; 
		    	}
				popupTitle = $rootScope.fnConvLanguage('FTYPE',$rootScope.ftype);
				break;
			
    	}
        $scope.headerText = popupTitle;
        $scope.popupType=type;
        $scope.modal.show();
    };
    
    // 하위 데이터를 불러온다. 
    $scope.getListIndex = function(items,code){
    	var index = 0;
    	for (var i = 0; i < items.length; i++) {
			if(angular.equals(items[i].code, code)){
				index = i;
				break;
			}
		}
    	return index;
    };
    
    $scope.chkUndefined = function(data){
    	if(data == undefined  || data == null ){
    		return true;
    	}else{
    		return false;
    	}
    };
    
	$ionicModal.fromTemplateUrl('kts-conv/view/searchCodeModal.html', {
		scope: $scope,
		animation: 'no-animation',
		focusFirstInput : true
	}).then(function(modal) {
		$scope.codeModal = modal;
	});
  

	  
	$ionicModal.fromTemplateUrl('kts-comm/view/fancy-conv-items.html', {
		scope: $scope,
		animation: 'slide-in-right'
	}).then(function(modal) {
		$scope.modal = modal;
	});
	$scope.show = function() {
		$scope.modal.show();
	};
	$scope.hideItems = function() {
		$scope.modal.hide();
		$scope.isFtypeBtnView = 'true';
	};
	//Cleanup the modal when we're done with it!
	$scope.$on('$destroy', function() {
		$scope.modal.remove();
	});
	// Execute action on hide modal
	$scope.$on('modal.hidden', function() {
	// Execute action
	});
	// Execute action on remove modal
	$scope.$on('modal.removed', function() {
	// Execute action
	});
	/* Validate selection from header bar */
	$scope.validate = function (event) {
		// Construct selected values and selected text
		if ($scope.multiSelect == true) {
			
			// Clear values
			$scope.value = '';
			$scope.text = '';
			
			// Loop on items
			jQuery.each($scope.items, function (index, item) {
				if (item.checked) {
					$scope.value = $scope.value + item.id+';';
					$scope.text = $scope.text + item.text+', ';
				}
			});
			
			// Remove trailing comma
			$scope.value = $scope.value.substr(0,$scope.value.length - 1);
			$scope.text = $scope.text.substr(0,$scope.text.length - 2);
		}
		
		// Select first value if not nullable
		if (typeof $scope.value == 'undefined' || $scope.value == '' || $scope.value == null ) {
			if ($scope.allowEmpty == false) {
				$scope.value = $scope.items[0].id;
				$scope.text = $scope.items[0].text;
				
				// Check for multi select
				$scope.items[0].checked = true;
			} else {
				$scope.text = $scope.defaultText;
			}
		}
		$scope.hideItems();
	};
  
	$scope.validateSingle = function (item,code) {
		switch($scope.popupType){
			case 'lmf':
				$scope.code.lmf= code;
				$scope.lmfName = $rootScope.getText(item.name);
				$scope.code.app = undefined;
				$scope.code.item= undefined;
				$scope.appName = $rootScope.transConv('conv01');
				$scope.itemName = $rootScope.transConv('conv01');
			break;
			case 'app':
				$scope.code.app= code;
				$scope.appName = $rootScope.getText(item.name);
				$scope.code.item= undefined;
				$scope.itemName = $rootScope.transConv('conv01');
			break;
			case 'item':
				$scope.code.item= code;
				$scope.itemName = item.code;
			break;
		}
		// Hide items
		$scope.search.string = "";
		$scope.hideItems();
	};
	$scope.showSearch = function(){
		//$scope.isFtypeBtnCheck = false;
		$scope.searchFlag = true;
		$scope.codeModal.show();
		focus('focusMe');
		//$rootScope.searchView = true;
	};
	$scope.hideSearch = function(){
		$scope.search.item = ""; // search 초기화
		$scope.searchItems = []; 
		//$scope.isFtypeBtnCheck = true;
		$scope.searchFlag = false;
		$scope.codeModal.hide();
		//$rootScope.searchView = false;
	};    
    
    // 필터 한개씩 나오게 하는것. 
    $scope.moredata = false;
    $scope.loadMoreData=function(){	
    	$scope.searchItems.push($rootScope.ktsConvData.search[$scope.searchItems.length]);
        if($scope.searchItems.length==100)
        {
            $scope.moredata=true;
        }
      $scope.$broadcast('scroll.infiniteScrollComplete');
    };
    
    // 10개씩 스크롤 할때마다 넣어주는것. 
    $scope.searchItems=[];
    $scope.limit = 0;
    $scope.noMoreItemsAvailable = false;
    $scope.loadMore = function() {
	    $scope.limit +=30;
	    //console.log("$scope.limit : "+$scope.limit);
	    if ( $scope.searchItems.length <$scope.limit) {
	      $scope.noMoreItemsAvailable = true;
	    }
	    $scope.$broadcast('scroll.infiniteScrollComplete');
    };
   
	$scope.tabSelected = function(ftype) {
		//$scope.pageValue = ftype;
		$rootScope.changeData(ftype);
		$scope.converterInit(ftype);
		// menu log
		$rootScope.logService('01' ,'01' ,angular.equals(ftype,'CB')? 'MT02001': 'MT01001' );
	};
	
	$scope.selectManufacturer = function(item,idx){
		alert("!"); 
	};
	  
	var adjusting = false;
	$scope.scrollMirror = function(from, to) {
	    if (adjusting) {
	    	adjusting = false;
	    } else {
			// Mirroring zoom level
			var zoomFrom = $ionicScrollDelegate.$getByHandle(from).getScrollView().getValues().zoom;
			var zoomTo = $ionicScrollDelegate.$getByHandle(to).getScrollView().getValues().zoom;
			
			if (zoomFrom != zoomTo) {
			$ionicScrollDelegate.$getByHandle(to).getScrollView().zoomTo(zoomFrom);
			}
			
			// Mirroring left position
			$ionicScrollDelegate.$getByHandle(to).scrollTo($ionicScrollDelegate.$getByHandle(from).getScrollPosition().left,
			$ionicScrollDelegate.$getByHandle(to).getScrollPosition().top);
			
			adjusting = true;
	    }
	};
	$scope.search = {
			string:''
	};
	  
	var selectItem = {id:3, text:'Japan', checked:true, icon:null};
	$scope.code =  [];
	 
	 // find click event
	$scope.findBtn = function(){
		if(angular.isUndefined($scope.code.lmf) || angular.isUndefined($scope.code.app) || angular.isUndefined($scope.code.item)){
			$rootScope.pop('info','',$rootScope.transConv('alert05'));
			return;
		}
		$rootScope.convDataTitle = $rootScope.fnConvLanguage('FTYPE',$rootScope.ftype);
		$rootScope.convData = $scope.appItems[$scope.getListIndex($scope.appItems, $scope.code.item)].convert;
		$rootScope.convDataCode =  $rootScope.getText($rootScope.lmf[$scope.getListIndex($rootScope.lmf,$scope.code.lmf)].name)
		+" > "+$scope.code.item;
		
		$rootScope.$broadcast("RESULT_VIEW_CLEAR"); //detailView 초기화
		
        /*
            app : {01:재종변환기, 02:절삭계산기} , flag : {01:메뉴, 02:재종코드} ,code : "메뉴코드", "재종코드",
            os : {01:Android, 02:IOS, 03:WEB} , cptCode : "경쟁사코드" , appCode : "어플리케이션 코드"
        */		
        // menu log
		$rootScope.logService('01' ,'01' ,angular.equals($rootScope.ftype,'CB')? 'MT02001': 'MT01001' );
    	// select log
		$rootScope.logService('01' ,'02' ,$scope.code.item , $scope.code.lmf  ,$scope.code.app );
		$location.path('/kts/resultView');
		
	};
	
	$scope.selectApplication = function(mcode,code){
		if(mcode == 'GD'){
			$scope.appitems = $filter('filter')(ktsConvData.data.competitors, ktsConvData.data.applications.name);
		};
	};
                      
	//search click event
    $scope.selectItem = function(item){
    	$rootScope.convDataTitle = "";
    	$rootScope.convDataTitle = $rootScope.fnConvLanguage('FTYPE',item.ftype); // result view title
    	$rootScope.convData = item.convert;
    	$rootScope.convDataCode = $rootScope.fnConvLanguage('COMP',item.competitors,'',$rootScope.lang)
        													+" > "+item.item;
    	
    	$scope.hideSearch(); // search modal hide
    	/*
            app : {01:재종변환기, 02:절삭계산기} , flag : {01:메뉴, 02:재종코드} ,code : "메뉴코드", "재종코드",
            os : {01:Android, 02:IOS, 03:WEB} , cptCode : "경쟁사코드" , appCode : "어플리케이션 코드"
        */		
        // menu log
		$rootScope.logService('01' ,'01' ,'MT00002' );
    	// select log
		$rootScope.logService('01' ,'02' ,item.item , item.competitors  , item.applications );
		$rootScope.$broadcast("RESULT_VIEW_CLEAR"); // detailView 초기화
    	$location.path('/kts/resultView');
		
    };
    
     // search 초기화
    $scope.$watch('search.item', function(newValue, oldValue) {
        if (newValue === oldValue) { return; }
        
        if (newValue.length > 0) {
        	$scope.searchItems = $rootScope.ktsConvData.search;
        } else{
        	$scope.limit = 0;
        	return;
        }
        
        $scope.limit = 30;
      }, true);
    
    // search filter 
    $scope.fnfilterGrade = function (searchName){
    	
    	return function (items) {
    		var isCheck;
    		if(!$scope.chkUndefined(items.item)){
    			isCheck = (
        				items.item.toLowerCase().match( searchName.toLowerCase())
        				//&& items.ftype.toUpperCase()== $rootScope.ftype // 재종별 필터
        				);
    		}
    		
    		return isCheck;
    	};
    };
    
    // search filter check
    $scope.fnfilerItem = function (str){
    	return function (items) {
    		var searchName = str || "";
    		var isCheck = true;
    		if(!angular.equals(searchName,"")){
    			isCheck = ($rootScope.getText(items.name).toLowerCase().match( searchName.toLowerCase()));
    		}
    		return isCheck;
    	};
    };
    // 다국어 정렬 name 반환
    $scope.fnGetSortName = function (){
    	return 'name.'+$rootScope.lang;
    };
    // 컨트롤러 처음 실행시 실행. 
	$scope.converterInit('GD'); 
	
	//태그 접촉 취소할 시
	$ionicPlatform.onHardwareBackButton(function () {
		if($scope.searchFlag) {
			//$scope.searchFlag = false;
			$scope.hideSearch();
		}
	});	
	
})
.controller('ResultCtrl', function($scope,$location,$ionicScrollDelegate,$filter,$rootScope,$ionicModal,httpService,$ionicPopup, $timeout) {
	//$scope.detailData={code:"" ,url:"" ,desc:"" ,isVision:false ,isUrl:false} ;
	//$scope.viewData = [];
	
	$rootScope.$on('RESULT_VIEW_CLEAR', function(event, pageNo) {
		event.preventDefault();
		$scope.detailViewInit();
	});
	
	$scope.detailViewInit = function(){
		$scope.detailData={code:"" ,url:"" ,desc:"" ,isVision:false ,isUrl:false} ;
		$scope.viewData = $scope.convViewData($rootScope.convData);
		
	};
	
	$scope.fnViewDataDetail = function(code,url,desc){
		
		$scope.detailData.code = code;
		$scope.detailData.url = url;
		$scope.detailData.desc = $rootScope.getText(desc);
		$scope.detailData.isVision = true;
		$scope.detailData.isUrl = (url == "")? false : true;
		
		$scope.detailDesc = $scope.detailData.desc;
		
		if(angular.equals($scope.detailDesc,"")){
			$scope.detailDesc = $rootScope.transConv('conv08');
		}
		
	};
	
	$scope.fnSplitCode = function(code){
		if (code == "")return "";
			
		var resultCode;
		var splitCode = code.split("-");
		resultCode = splitCode[splitCode.length-1];
		return resultCode ;
	};
	
	$scope.convViewData = function(convert){
		$scope.ktsConvKeyword = $rootScope.ktsConvData.keyword;
		var result = [];
		for ( var i in convert) {
			var data = new Array();
			for ( var j in convert[i].data) {
				var dataDetail = new Array();
				for ( var z in convert[i].data[j]) {
					var viewData = new Array();
					var isKeyword = false;
					
					for( var i2 in $scope.ktsConvKeyword) {
						if(angular.equals(convert[i].data[j][z],$scope.ktsConvKeyword[i2].code)){
							viewData.push({
								  //code:$scope.fnSplitCode($scope.ktsConvKeyword[i2].code),
								  code:$scope.ktsConvKeyword[i2].name,
								  url:$scope.ktsConvKeyword[i2].url,
								  dispType:$scope.ktsConvKeyword[i2].dispType,
								  desc:$scope.ktsConvKeyword[i2].desc,
								  isData:$scope.ktsConvKeyword[i2].useYn == 'Y' ? true : false
								  });
							isKeyword = true;
							
						}
						
					}
					if(!isKeyword) {
						viewData.push({
							  //code: $scope.fnSplitCode(convert[i].data[j][z]),
							  code: "",
							  url:"",
							  dispType:"",
							  desc:{"ko" : "","en" : ""},
							  isData:false
							  });
					}
					
					dataDetail.push(viewData);
					
				}
				data.push(dataDetail);
			};
			result.push({	
				code : convert[i].code,
				data : data
			});
		};
    	return result;
    };
	

    $scope.detailViewInit();
    
	$scope.fnUrlOpen = function(url){
		$rootScope.OpenWindow(url);
	};

	$scope.fnBorderStyle = function(code , idx){
		if(code == 'H'&& idx ==1){
			return {"border-right":"2px solid red","border-bottom":"2px solid red"};
		} if(idx !=2){
			return {"border-right":"2px solid red"};
		}

		return {};
	}
	
})
.controller('ConverterCtrl1', function() {
	
});
